#ifndef _SORTING_H_
#define _SORTING_H_

#include "formula.h"
#include <queue>

class CompareFormulaeByWeight {
 public:
  CompareFormulaeByWeight() { }
  
  bool operator() (Formula* formula1, Formula* formula2) {
    return formula1->getId()->weight * log(formula1->getId()->ADlocal) > 
      formula2->getId()->weight * log(formula2->getId()->ADlocal);
  }
};

class CompareFormulaeByCrap {
 public:
  CompareFormulaeByCrap() { }
  
  bool operator() (Formula* formula1, Formula* formula2) {
    return formula1->getId()->crappiness > formula2->getId()->crappiness;
  }
};

class CompareFormulaeByAge {
 public:
  CompareFormulaeByAge() { }
  
  bool operator() (Formula* formula1, Formula* formula2) {
    return formula1->getId()->ADlocal < formula2->getId()->ADlocal;
  }
};

class CompareFormulaeByKBO {
 public:
  CompareFormulaeByKBO() { }
  
  bool operator() (Formula* formula1, Formula* formula2) {
    return formula1->getId()->wKBO > formula2->getId()->wKBO;
  }
};

typedef priority_queue<Formula*, vector<Formula*>, CompareFormulaeByWeight> WEIGHTq;
typedef priority_queue<Formula*, vector<Formula*>, CompareFormulaeByCrap> CRAPq;
typedef priority_queue<Formula*, vector<Formula*>, CompareFormulaeByAge> AGEq;
typedef priority_queue<Formula*, vector<Formula*>, CompareFormulaeByKBO> KBOq;


#endif
