#ifndef PRINTTSTP_H
#define PRINTTSTP_H
//-----------------------------------------------------------------------------
#include "DataTypes.h"

typedef enum {
    tptp,
    tptp_short,
    oldtptp,
    dfg,
    otter,
    kif,
    xml,
    xml_short,
    nonprinttype
} PrintFormatType;
//-----------------------------------------------------------------------------
PrintFormatType StringToPrintFormat(char * String);
char * PrintFormatToString(PrintFormatType Format);

void PrintIndent(FILE * Stream,int Indent,int AlreadyIndented,int Pretty);
void PrintTSTPTerm(FILE * Stream,TERM Term,int TSTPSyntaxFlag);
void PrintTSTPFormula(FILE * Stream,FORMULA Formula,int Indent,
int AlreadyIndented,int Pretty,ConnectiveType LastConnective,
ConnectiveType NextConnective,int TSTPSyntaxFlag);
void PrintAnnotatedTSTPFormula(FILE * Stream,SyntaxType Syntax,
AnnotatedTSTPFormulaType AnnotatedTSTPFormula,PrintFormatType Format,
int Pretty);
void PrintAnnotatedTSTPNode(FILE * Stream,ANNOTATEDFORMULA AnnotatedFormula,
PrintFormatType Format,int Pretty);
void PrintAnnotatedTSTPNodeWithStatus(FILE * Stream,ANNOTATEDFORMULA
AnnotatedFormula,PrintFormatType Format,int Pretty,StatusType Status);
void PrintListOfAnnotatedTSTPNodes(FILE * Stream,SIGNATURE Signature,
LISTNODE Head,PrintFormatType Format,int Pretty);
void PrintListOfAnnotatedTSTPNodesWithStatus(FILE * Stream,SIGNATURE Signature,
LISTNODE Head,PrintFormatType Format,int Pretty,StatusType Status);
//-----------------------------------------------------------------------------
#endif
