

// Written by Hans de Nivelle, February 2006.


#ifndef SUBSUMPTION_INCLUDED
#define SUBSUMPTION_INCLUDED   1


#include "partial.h"
#include "rulesystem.h"
#include "varmatching.h" 
#include "varset.h"


namespace subsumption 
{

   partial< varmatching >
   findselfsubsumption( const rule& self_rule );
      // Returns a varmatching from self_rule into self_rule,
      // s.t. at least one variable of self_rule does not occur in
      // the range.

   partial< varmatching > 
   findsubsumption( const rule& from_rule, const rule& into_rule );
      // Returns a subsuming varmatching in case there exists one. 

   bool check_subsumption( const varmatching& base,
            const rule& from_rule, const rule& into_rule );


   void test_swll_subsumption( const rulesystem& rs );
      // Test whether the first rule in rs subsumes the second
      // rule in rs. 

}



#endif


