package org.mathweb.atp;

import java.io.*;
import java.util.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import javax.xml.namespace.QName;
import javax.xml.rpc.ParameterMode;

import org.jdom.*;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.encoding.XMLType;

import org.mindswap.query.ValueMap;

import org.mathweb.owls.OWLSParser;
import org.mathweb.onto.OWLJDom;
import org.mathweb.util.Java2WSDL;
import org.mathweb.util.TSTPCreator;
import org.mathweb.serv.ReasoningService;


public class EClient
{

  public String readFile(String fileName){
    try {
      FileInputStream isFile = new FileInputStream(fileName);
      int nChar;
      StringBuffer sbRead = new StringBuffer();
      nChar = isFile.read();
      while (nChar > -1) {
        sbRead.append((char) nChar);
        nChar = isFile.read();
      }
      isFile.close();
      return sbRead.toString();
    } catch (IOException ioe) {
      return null;
    }
  }

  public static void main(String [] args) {
    String msHome = System.getProperty("mathserv.home");
    OWLJDom owlJDom = OWLJDom.getInstance();
    TSTPCreator creator = new TSTPCreator();



    int time = 30;
    String timeInd = owlJDom.createTimeIndi(time, time);
    Integer timeInt = new Integer(time);
    
    /* runt org.mathweb.atp.EClient lambda.ags.uni-sb.de /home/jzimmer/nb/Casc/unsolved-chose-spass-instead-e /home/jzimmer/nb/Casc/Active 600

    */
    //    String timeInd = owlJDom.createTimeIndi(8, 8);
    try {
      String hostname;
      if ((args.length > 0) && (!args[0].trim().equals(""))) 
	hostname = args[0];
      else 
	hostname = "localhost";
      
//       String listFileName = args[1];
//       String prefix = args[2];
//       String timeStr = args[3];
//       int time =  Integer.parseInt(timeStr);
//       Integer timeInt = new Integer(time);
      
      String endpoint = "http://" + hostname + ":8080/axis/services/EService";
      OWLSParser owlsParser = new OWLSParser();
      
      EClient c = new EClient();

      Service service = new Service();

//       Call init = (Call) service.createCall();
      
//       init.setTargetEndpointAddress(new java.net.URL(endpoint));
//       init.setOperationName("createNewInstance");
//       init.setReturnType(XMLType.SOAP_STRING);

//       /*  get a new APT object ID  */
//       String atpID = (String) init.invoke(new Object [] {});
      
//       System.out.println("object ID: " + atpID);
      
      String fofProb;
      String tptpProb;
      
      fofProb = creator.tstp2OWLProblem(msHome + "/thirdParty/TPTPWorld/TPTP/Problems/PUZ/PUZ001+1.p");
      fofProb = creator.tstp2OWLProblem("/home/jzimmer/fuer_Juergen.tptp");
      
      tptpProb = creator.readFile(msHome + "/examples/tptp/agatha-fof.tptp");
      
      Call call = (Call) service.createCall();
      call.setTargetEndpointAddress(new java.net.URL(endpoint));
      call.addParameter("in0", XMLType.SOAP_STRING, ParameterMode.IN);
      //      call.addParameter("in1", XMLType.SOAP_STRING, ParameterMode.IN);
      call.addParameter("in1", XMLType.SOAP_INT, ParameterMode.IN);
      call.setReturnType(XMLType.SOAP_STRING);
      call.setTimeout(new Integer((time + 120)*1000));

      call.setOperationName("proveProblem");
      String result = (String) call.invoke( new Object [] {fofProb, timeInd});
      //      call.setOperationName("proveTPTPProblem");
      //      String result = (String) call.invoke( new Object [] {tptpProb, timeInt});
      System.out.println(result);

//       Call kill = (Call) service.createCall();

//       kill.setTargetEndpointAddress(new java.net.URL(endpoint));
//       kill.setOperationName("killInstance"); 
//       kill.addParameter("in0", XMLType.SOAP_STRING, ParameterMode.IN);
//       kill.setReturnType(XMLType.SOAP_STRING);

//       kill.invoke(new Object [] {atpID});

      
//       fofProb = c.readFile(msHome + "/examples/owl/cnf3.owl");
//       fofProb = creator.tstp2OWLProblem(msHome + "/thirdParty/TPTPWorld/TPTP/Problems/LCL/LCL181-3.p");
      
//       timeInd =  c.readFile(msHome + "/examples/owl/time.owl");
      
//       String wsdl = null;
//       Vector ms = new Vector();
//       ms.add("proveProblem");
      
//       wsdl = (new Java2WSDL()).java2WSDL(hostname, "EService", "org.mathweb.atp.E" , ms );
//       System.out.println(" wsdl:  " + wsdl);
      
//       ReasoningService service = owlsParser.parseServiceFile(msHome + "/etc/services/owls/1.1/EService.owl", wsdl);
//       System.out.println("Service " + service);
//       Hashtable map = new Hashtable();
//       map.put("tstp_problem", fofProb);
//       map.put("time_res", timeInd);
      
//       ValueMap resTab = service.invokeOWLS(map);
//       System.out.println("Sent problem and got '" + resTab + "'");
             

//       Service service = new Service();
//       Call call = (Call) service.createCall();

//       call.setTargetEndpointAddress(new java.net.URL(endpoint));
//       call.setOperationName("proveProblem");
//       call.addParameter("in0", XMLType.SOAP_STRING, ParameterMode.IN);
//       call.addParameter("in1", XMLType.SOAP_STRING, ParameterMode.IN);
//       call.setReturnType(XMLType.SOAP_STRING);
//       call.setTimeout(new Integer((time + 120)*1000));

//       String[] problems = c.readFile(listFileName).split("\n");
//       for(int i = 0; i< problems.length; i++){
//           String probFile = prefix + "/" + problems[i].trim();
//           String prob = creator.tstp2OWLProblem(probFile);
          
//           System.out.print(probFile + "\t");
//           try {
//               String result = (String) call.invoke( new Object [] {prob, timeInd });
//               System.out.println(result);
//               Element resultRoot = owlJDom.getRootElement(result);
//               Double wcDouble = (Double) OWLJDom.TIME_RESOURCE_WC.numberValueOf(resultRoot);
//               Double cpuDouble = (Double) OWLJDom.TIME_RESOURCE_CPU.numberValueOf(resultRoot);
//               String status = OWLJDom.STATUS.valueOf(resultRoot);
//               String rdfID = OWLJDom.POTENTIAL_ID.valueOf(resultRoot);
//               System.out.println(status);
//           } catch (Exception e) {
//             e.printStackTrace();
//             System.out.println(e.toString());
//           }
//       }
      
    } catch (Exception e) {
        System.err.println(e.toString());
    }
  }
}
