// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathServe system

Authors: Juergen Zimmer

email: jzimmer@ags.uni-sb.de
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB Informatik                                            
Universitaet des Saarlandes                                          
Gebaeude E 1.1                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathServe, see 
http://www.ags.uni-sb.de/~jzimmer/mathserve.html

See the file "LICENSE.txt" or
http://www.ags.uni-sb.de/~jzimmer/LICENSE.html
for information on usage and redistribution
of this file, and for a DISCLAIMER OF ALL WARRANTIES.
*****************************************************************/

//  For testing:

package org.mathweb.broker;

import java.io.*;
import java.util.*;

import salvo.jesus.graph.*;

import org.jdom.*;

/**
   @author Juergen Zimmer, Saarland University, Germany
   @version $Date: 2006/02/13 12:59:23 $ $Revision: 1.3 $
*/

class ServicePlan
{
  private DirectedGraph graph;
  private Element prodigyPlan;
  
  public ServicePlan()
  {
    graph = null;
    prodigyPlan = null;
  }

  public ServicePlan(DirectedGraph gr, Element prodigy)
  {
    graph = gr;
    prodigyPlan = prodigy;
  }

  public DirectedGraph getGraph()
  {
    return graph;
  }

  public void setGraph(DirectedGraph gr)
  {
    graph = gr;
  }

  public Element getProdigyPlan()
  {
    return prodigyPlan;
  }

  public void setProdigyPlan(Element prod)
  {
    prodigyPlan = prod;
  }
  
}
