// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathServe system

Authors: Juergen Zimmer

email: jzimmer@ags.uni-sb.de
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB Informatik                                            
Universitaet des Saarlandes                                          
Gebaeude E 1.1                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathServe, see 
http://www.ags.uni-sb.de/~jzimmer/mathserve.html

See the file "LICENSE.txt" or
http://www.ags.uni-sb.de/~jzimmer/LICENSE.html
for information on usage and redistribution
of this file, and for a DISCLAIMER OF ALL WARRANTIES.
*****************************************************************/

/** For testing:

runt org.mathweb.broker.XmlRpcBrokerClient /home/jzimmer/import/mathserve/thirdParty/TPTPWorld/TPTP/Problems/PUZ/PUZ001+1.p 


*/
package org.mathweb.broker;

import java.io.*;
import java.util.*;

import java.util.Enumeration;
import java.util.ArrayList;
import java.util.Iterator;

import org.apache.xmlrpc.*;

import org.apache.log4j.Level;
import org.apache.log4j.Logger; 
import org.apache.log4j.FileAppender; 
import org.apache.log4j.SimpleLayout; 
import org.apache.log4j.PatternLayout; 

import org.jdom.*;

import org.mathweb.util.*;
import org.mathweb.onto.*;
import org.mathweb.core.BasicService;


/**
   @author Juergen Zimmer, Saarland University, Germany
   @version $Date: 2006/02/13 12:59:23 $ $Revision: 1.13 $
*/
public class XmlRpcBrokerClient extends BasicService {
  
  private static Logger logger = Logger.getLogger("XmlRpcBrokerClient");
  private static String logFileName = getSystemProperty("xmlrpcbroker.log.file", "XMLRPCBROKER_LOG_FILE");
  private static FileAppender appender = newAppender(logFileName);

  private org.apache.xmlrpc.XmlRpcClient brokerConnection;

  public XmlRpcBrokerClient()  {
    super();
    logger.setLevel(Level.ALL);
    logger.setLevel(Level.OFF);
    if (!logger.getAllAppenders().hasMoreElements()) logger.addAppender(appender);
  }
  
  private void test(String hostname, int port, String testproblem, int time)   {
      //System.out.println(problem);
      OWLJDom owlJDom = OWLJDom.getInstance();
      
      String url = "http://" + hostname + ":" + port;
      try { 
        brokerConnection = new org.apache.xmlrpc.XmlRpcClient(url);
//       System.out.println(brokerConnection);
//         String[] landau = new String[] {"landau0/_10_T5_THM.p",
//                                         "landau0/_EC3E13_HTHM.p",
//                                         "landau0/_ISSET_T1_THM.p",
//                                         "landau0/_NOTIS_TH1_THM.p",
//                                         "landau0/_NOTIS_TH3_THM.p",
//                                         "landau0/_ONEI_THM.p",
//                                         "landau0/_R_ITE_T6_THM.p",
//                                         "landau1/_24_T9_THM.p",
//                                         "landau1/_327_T16_HTHM.p",
//                                         "landau1/_428_T2_HTHM.p",
//                                         "landau1/_SATZ31_HTHM.p",
//                                         "landau1/_SATZ32K_HTHM.p",
//                                         "landau1/_SATZ9A_HTHM.p",
//                                         "landau1/_SINGLET_T1_HTHM.p"
                                        //,
//                                         "landau2/_255_T2_HTHM.p",
//                                         "landau2/_54_T18_HTHM.p",
//                                         "landau2/_59_T11_HTHM.p",
//                                         "landau2/_59_T16_HTHM.p",
//                                         "landau2/_EQPF12_HTHM.p",
//                                         "landau2/_SATZ67E_HTHM.p",
//                                         "landau2/_SATZ73C_HTHM.p",
//                                         "landau3/_3129_T8_HTHM.p",
//                                         "landau3/_4150_T7_HTHM.p",
//                                         "landau3/_4152_T31_HTHM.p",
//                                         "landau3/_4153_T2_HTHM.p",
//                                         "landau3/_5155_T14_HTHM.p",
//                                         "landau3/_5160_T31_HTHM.p",
//                                         "landau3/_SATZ148B_HTHM.p",
//                                         "landau4/_4D192_T8_HTHM.p",
//                                         "landau4/_ABSN_HTHM.p",
//                                         "landau4/_INTD_T7_HTHM.p",
//                                         "landau4/_M0DEQB_HTHM.p",
//                                         "landau4/_REMARK3B_HTHM.p",
//                                         "landau4/_SATZD171_HTHM.p",
//                                         "landau4/_SATZD197F_HTHM.p",
//                                         "landau5/_8281_T12_HTHM.p",
//                                         "landau5/_8283_T23_HTHM.p",
//                                         "landau5/_8285_T23_HTHM.p",
//                                         "landau5/_C_SHIFTINV1_HTHM.p",
//                                         "landau5/_DISTPO_HTHM.p",
//                                         "landau5/_SATZ295_HTHM.p",
//                                         "landau5/_T136_HTHM.p"
//};
        
//        int time = 30;
      
//       for(int i=0; i< landau.length; i++){
        
//         String problem = readFile(msHome + "/examples/tptp/landau/" + landau[i]);
        
        Vector params = new Vector();
        params.addElement(testproblem);
        params.addElement(new Integer(time));
        //        System.out.println(params);
      
        String method = "proveProblemOpt";
        //       Object resultChoice = brokerConnection.execute(command, params);
        
        //       method = "proveProblemSplit";
        //       Object resultSplit = brokerConnection.execute(command, params);
        
        //       method = "proveProblemOpt";
        //       Object resultOpt = brokerConnection.execute(command, params);
        
        //       System.out.println("choice: " + resultChoice);
        //       System.out.println("split: " + resultSplit);
        //       System.out.println("opt: " + resultOpt);
        
        // Object zenonRes = brokerConnection.execute("proveProblemFocal", params);
        //      Object brokerRes = brokerConnection.execute("proveOmdocProblem", params);
        try { 
          String brokerRes = (String) brokerConnection.execute(method, params);
          //       params = new Vector();
          //       Object brokerRes = brokerConnection.execute("ping", params);
          
          Element resultRoot = owlJDom.getRootElement(brokerRes);
          Double wcDouble = (Double) OWLJDom.TIME_RESOURCE_WC.numberValueOf(resultRoot);
          Double cpuDouble = (Double) OWLJDom.TIME_RESOURCE_CPU.numberValueOf(resultRoot);
          String status = OWLJDom.STATUS.valueOf(resultRoot);
          String rdfID = OWLJDom.POTENTIAL_ID.valueOf(resultRoot);
          //          System.out.println("result" + "\t" + rdfID + "\t" + status);
          System.out.println(brokerRes);
          
          //          writeFile(msHome + "/examples/tptp/landau/results" + landau[i] + "-result", brokerRes);
        } catch (Exception e) {
          e.printStackTrace();
          System.out.println("broker error " + e.getMessage());
        }
        //    }
      } catch (Exception e) {
        e.printStackTrace();
        System.out.println("broker error " + e.getMessage());
      }
      
  } // end test()
  
  
  /*  the name a TSTP file. */
  public static void main(String argv[]) throws Exception {
    XmlRpcBrokerClient client = new XmlRpcBrokerClient();
    String problemFile = null;
    if (argv.length > 2) {
      String hostname = argv[0];
      int port = Integer.parseInt(argv[1]);
      problemFile = argv[2];
      int time = Integer.parseInt(argv[3]);      
      String problem = client.readFile(problemFile);
      client.test(hostname, port, problem, time);
    } else 
      System.out.println("Usage: bin/runt org.mathweb.broker.XmlRpcBrokerClient <hostname> <port> <problem file>");
  }
  
} // end XmlRpcBrokerClient.java

      
/* Settings for Emacs.
 * Local variables:
 * c-basic-offset: 2
 * tab-width: 2
 * indent-tabs-mode: nil
 * End:
 */
