// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathServe system

Authors: Juergen Zimmer

email: jzimmer@ags.uni-sb.de
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB Informatik                                            
Universitaet des Saarlandes                                          
Gebaeude E 1.1                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathServe, see 
http://www.ags.uni-sb.de/~jzimmer/mathserve.html

See the file "LICENSE.txt" or
http://www.ags.uni-sb.de/~jzimmer/LICENSE.html
for information on usage and redistribution
of this file, and for a DISLAIMER OF ALL WARRANTIES.
*****************************************************************/
package org.mathweb.gen;

import java.io.*;
import java.util.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import javax.xml.namespace.QName;
import javax.xml.rpc.ParameterMode;

import org.jdom.*;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.encoding.XMLType;

public class MathsaidClient
{

  public static String readFile(String fileName){
    try {
      FileInputStream isFile = new FileInputStream(fileName);
      int nChar;
      StringBuffer sbRead = new StringBuffer();
      nChar = isFile.read();
      while (nChar > -1) {
        sbRead.append((char) nChar);
        nChar = isFile.read();
      }
      isFile.close();
      return sbRead.toString();
    } catch (IOException ioe) {
      return null;
    }
  }

  public static void main(String [] args) {
    String msHome = System.getProperty("mathserv.home");
    OMDocJDom omdocJDom = OMDocJDom.getInstance();

    int time = 30;
    String timeInd = omdocJDom.createTimeIndi(time, time);
    
    /* runt org.mathweb.atp.MathsaidClient lambda.ags.uni-sb.de /home/jzimmer/nb/Casc/Active 600

    */

    try {
      String hostname;
      if ((args.length > 0) && (!args[0].trim().equals(""))) 
	hostname = args[0];
      else 
	hostname = "localhost";
      
      
      String endpoint = "http://" + hostname + ":8080/axis/services/MathsaidService";
      
      String omdoc = MathsaidClient.readFile("/home/jzimmer/puz.omdoc");
      String omdocTheory = omdocJDom.createTheory(omdoc);
      
      Service service = new Service();
      Call call = (Call) service.createCall();
      call.setTargetEndpointAddress(new java.net.URL(endpoint));
      call.setOperationName("generateTheorems");
      call.addParameter("in0", XMLType.XSD_STRING, ParameterMode.IN);
      call.addParameter("in1", XMLType.XSD_STRING, ParameterMode.IN);
      call.setReturnType(XMLType.XSD_STRING);
      call.setTimeout(new Integer((time + 120)*1000));

      String result = (String) call.invoke( new Object [] {omdocTheory, timeInd});
      System.out.println(result);
      
    } catch (Exception e) {
        System.err.println(e.toString());
    }
  }
}
