// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathServe system

Authors: Juergen Zimmer

email: jzimmer@ags.uni-sb.de
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB Informatik                                            
Universitaet des Saarlandes                                          
Gebaeude E 1.1                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathServe, see 
http://www.ags.uni-sb.de/~jzimmer/mathserve.html

See the file "LICENSE.txt" or
http://www.ags.uni-sb.de/~jzimmer/LICENSE.html
for information on usage and redistribution
of this file, and for a DISCLAIMER OF ALL WARRANTIES.
*****************************************************************/
package org.mathweb.serv;

//import nl.tue.win.riaca.openmath.lang.OMObject;

import java.util.ArrayList;
import java.util.List;

import org.mathweb.serv.*;
import org.mathweb.reasoning.logic.*;

/**
 * Example of a useful base class for handing agent arguments.
 * Classes which formerly extended jade.Agent may now extend this class.
 */
public class StochasticEffect {

  private String name; 
  public String docu;
  public PreCondition condition;
  public Effect effect;
  public Float probability;
  public Integer cost;
  public Integer reward;


  public StochasticEffect ()
  {
    name = "";
    docu = "";
    condition = null;
    probability = new Float(0.0);
    cost = new Integer(0);
  }
  
  public StochasticEffect(PreCondition  cond, Effect eff, Float prob, Integer co){
    name = "";
    docu = "";
    condition = cond;
    effect = eff;
    probability = prob;
    cost = co;
    reward = new Integer(0);
  }

  public StochasticEffect(PreCondition  cond, Effect eff, Float prob, Integer co, Integer rewardInt){
    name = "";
    docu = "";
    condition = cond;
    effect = eff;
    probability = prob;
    cost = co;
    reward = rewardInt;
  }
  
  public PreCondition getCondition()
  {
    return condition;
  }

  public Effect getEffect()
  {
    return effect;
  }

  public Float getProbability()
  {
    return probability;
  }
  
  public Integer getCost()
  {
    return cost;
  }
  
  public Integer getReward()
  {
    return reward;
  }
  
  public void setCondition(PreCondition obj)
  {
    condition = obj;
  }
  public void setEffect(Effect obj)
  {
    effect = obj;
  }

  public void setName(String n)
  {
    this.name = n;
  }

  public String getName()
  {
    return name;
  }
  
  public String toString()
  {
    return name + ": " + condition + " => " + effect + " (" + probability + "; " + cost + ")";
  }

  
}

