// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathServe system

Authors: Juergen Zimmer

email: jzimmer@ags.uni-sb.de
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB Informatik                                            
Universitaet des Saarlandes                                          
Gebaeude E 1.1                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathServe, see 
http://www.ags.uni-sb.de/~jzimmer/mathserve.html

See the file "LICENSE.txt" or
http://www.ags.uni-sb.de/~jzimmer/LICENSE.html
for information on usage and redistribution
of this file, and for a DISCLAIMER OF ALL WARRANTIES.
*****************************************************************/
package org.mathweb.util;

import java.io.*;
import java.util.*;
import java.net.URI;

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import org.jdom.Namespace;
import org.jdom.JDOMException;
import org.jdom.xpath.XPath;
 
import org.mathweb.core.BasicService;
import org.mathweb.onto.OWLJDom;

/**
@author Juergen Zimmer, Saarland University, Germany
@version $Date: 2006/02/13 12:59:23 $ $Revision: 1.3 $
*/
public class PostCreator extends BasicService {
  private Quoter quoter = new Quoter();
  private static String xmlBase = "http://www.tptp.org/Problems#";
  private static OWLJDom owlJDom = OWLJDom.getInstance();
  private static String sep = File.separator;
  
//   public String postFOF2OWLSQuery(String postFOFProb) { 
//     return post2OWLSQuery(postFOFProb, "fof");
//   }
  
//   public String postCNF2OWLSQuery(String postCNFProb) {
//     return post2OWLSQuery(postCNFProb, "cnf");
//   }
  
//   public String post2OWLSQuery(String postProb) { 
//     if (postProb.indexOf("cnf(") > -1) 
//       return post2OWLSQuery(postProb, "cnf");
//     else
//       return post2OWLSQuery(postProb, "fof");
//   }
  
//   public String post2OWLSQuery(String postProb, String format) { 
//     try{
//       String name = "generated_post_" + format + "_problem_"+System.currentTimeMillis();
//       //      System.out.println(name);
//       String tail = readFile(msHome + sep + "etc" + sep + "post" + sep + "post-tail.xml");
//       String head = readFile(msHome + sep + "etc" + sep + "post" + sep + "post-head.xml"); 
//       return head + name + "\">\n"+
//         //        "  <mw:formalDescription rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">\n" +
//         "  <mw:formalDescription rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">\n" +
//         quoter.quote(postProb) +tail;
//     } catch(Exception e) {
//       return null;
//     }
//   }
  
//   public String postFile2OWLSQuery(String postFileName)
//   {
//     try{
//       File file = new File(postFileName);
//       String name = file.getName().replace('-', '_');
//       //      System.out.println(name);
//       String postProb = readFile(postFileName);
//       String format = null;
//       if (postFileName.indexOf("+") > -1) {
//         format = "fof";
//         name = name.replace('+', '_') + "_fof";
//       }
//       else format = "cnf";
//       name = name.replace('.', '_');
//       name = name + "_" + System.currentTimeMillis();
      
//       String tail = readFile(msHome + sep + "etc" + sep + "post" + sep + "tptp-"+format+"-tail.xml");
//       String head = readFile(msHome + sep + "etc" + sep + "post" + sep + "tptp-"+format+"-head.xml"); 
//       return head + name + "\">\n"+
//         "  <mw:formalDescription rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">\n" +
//         quoter.quote(postProb) +tail;
//     } catch(Exception e) {
//       return null;
//     }
//   }

  public String postFile2OWLProblem(String postFileName)
  {
    try{
      File file = new File(postFileName);
      String name = file.getName();
      name = name.replace('-', '_').trim();
      name = name.replace('+', '_');
      System.out.println(name);
      String postProb = readFile(postFileName);
      System.out.println(postProb);
      
      Element rdf = new Element("RDF",  OWLJDom.RDF_NS);
      rdf.setAttribute("base", xmlBase, Namespace.XML_NAMESPACE);
      rdf.addNamespaceDeclaration(OWLJDom.MW_NS);
      Element prob = new Element("PostProvingProblem",OWLJDom.MW_NS);
      prob.setAttribute("ID", name, OWLJDom.RDF_NS);

      Element format = new Element("format",OWLJDom.MW_NS);
      format.setAttribute("resource",  OWLJDom.MW_NS_STR+"POST", OWLJDom.RDF_NS);

      Element formalProb = new Element("formalDescription",OWLJDom.MW_NS);
      formalProb.addContent(postProb);

      Element probLogic = new Element("inLogic",OWLJDom.MW_NS); 
      probLogic.setAttribute("resource", "hol", OWLJDom.RDF_NS);

      prob.addContent(formalProb);
      prob.addContent(probLogic);
      rdf.addContent(prob);
      return owlJDom.newXMLDocument(rdf);
      
    } catch(Exception e) {
      e.printStackTrace();
      
      return null;
    }
  }
    
  public static void main(String[] args) {
    PostCreator creat  = new PostCreator();
    String result= creat.postFile2OWLProblem(args[0]);
    System.out.println(result);
    System.exit(0);
  }
}

  
  
