// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathServe system

Authors: Juergen Zimmer

email: jzimmer@ags.uni-sb.de
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB Informatik                                            
Universitaet des Saarlandes                                          
Gebaeude E 1.1                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathServe, see 
http://www.ags.uni-sb.de/~jzimmer/mathserve.html

See the file "LICENSE.txt" or
http://www.ags.uni-sb.de/~jzimmer/LICENSE.html
for information on usage and redistribution
of this file, and for a DISCLAIMER OF ALL WARRANTIES.
*****************************************************************/
package org.mathweb.util;

import java.io.*;
import java.util.*;

import org.apache.log4j.Level;
import org.apache.log4j.Logger; 
import org.apache.log4j.FileAppender; 
import org.apache.log4j.SimpleLayout; 

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import org.jdom.Namespace;
import org.jdom.JDOMException;
import org.jdom.xpath.XPath;

/**
@author Juergen Zimmer, Saarland University, Germany
@version $Date: 2006/02/13 12:59:23 $ $Revision: 1.8 $
*/
public class Quoter {
  
  public String readFile(String fileName){
    try {
      FileInputStream isFile = new FileInputStream(fileName);
      int nChar;
      StringBuffer sbRead = new StringBuffer();
      nChar = isFile.read();
      while (nChar > -1) {
        sbRead.append((char) nChar);
        nChar = isFile.read();
      }
      isFile.close();
      return sbRead.toString();
    } catch (IOException ioe) {
      return null;
    }
  }
  
  public String quote(String input){
    try {
      Text text = new Text(input);
      StringWriter writer = new StringWriter();
      Format format = Format.getPrettyFormat();
      format.setLineSeparator("\n");
      XMLOutputter outputter = new XMLOutputter(format);
      outputter.output(text, writer);
      //      System.out.println(writer.toString());
      return writer.toString();
    }
    catch(Exception ex){
      ex.printStackTrace();
      return null;
    }
  }
  
  public static void main(String[] args) {
    try {
      Quoter quote  = new Quoter();
      String string = quote.readFile(args[0]); 
      Element root = new Element("quoted", "http://www.tptp.org#");
      root.addContent("\n");
      root.addContent(string);
      StringWriter writer = new StringWriter();
      Document doc = new Document(root);
      Format format = Format.getPrettyFormat();
      format.setLineSeparator("\n");
      XMLOutputter outputter = new XMLOutputter(format);
      outputter.output(doc, writer);
      //      System.out.println(writer.toString());
    }
    catch(Exception ex){
      ex.printStackTrace();
    }
    System.exit(0);
  }
}

