;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; XML/RPC Mini Tools, ver. 0.1
;;
;;   Henri Lesourd, Saarland University
;;
;;   February 2006
;;
(define TEXMACS #f)
(define TEST-XMLRPC #f)
;(load "util00.scm")

;***********
;* Parsing
;*
(define curtag (make-string 10000))
(define curtag-ptr 0)
(define (xml-blank? c)
  (if (char? c)
      (begin
         (set! c (char->integer c))
         (or (eq? c 9) (eq? c 32) (eq? c 10) (eq? c 13)))
      #f)
)
(define open-attr "(")
(define close-attr ")")
(define hardcheck? #f)
(define prec-tag-value? #f)
(define val-as-string? #f)



					;TODO: Reparcourir l'arbre pour traduire les types
;  i.e. <string>A B C</string> ==> (string "A B C").
;
;  Pas correct de reparcourir apres, il faut que les
;    suites de plusieurs espaces soient preservees.
;    Donc <value>...<string> joue le meme role que
;    le '"' lors du parsing. Fait chier.
;    ==> Est-ce que c'est sur, ca ? Dans XML,
;        les espaces ne sont pas significatifs,
;        habituellement.


;****************
;* Pretty-print
;*
(define excluded-attrs '(_menu))
(define noindent-attrs '(tuple link _menu pl-constant pl-object set-inter set-union set-in pl-link
                         value int string))
(define litteral-attrs-val? #t)
(define (excluded-attr? name)
  (if (string? name)
      (set! name (string->symbol name)))
  (in? name excluded-attrs)
)
(define (noindent-attr? name)
  (if (string? name)
      (set! name (string->symbol name)))
  (in? name noindent-attrs)
)
(define spc-indent 0)
(define (xml-cr-indent)
  (if (>= spc-indent 0)
      (display* "\n" (make-string spc-indent #\space))
      )
  )

(define indent-tab 2)
(define (xml-cr-inc-indent)
  (xml-cr-indent)
  (set! spc-indent (+ spc-indent indent-tab))
)
(define (xml-inc-cr-indent)
  (set! spc-indent (+ spc-indent indent-tab))
  (xml-cr-indent)
)
(define (xml-dec-cr-indent)
  (set! spc-indent (- spc-indent indent-tab))
  (xml-cr-indent)
)
(define (xml-dec-indent)
  (set! spc-indent (- spc-indent indent-tab))
)

;;; sexpr example
;;;;  (mathserve (axiom (with "mode" "math" (concat "<forall>x. x=x <wedge> f(x)=c<wedge> " (appl "g" "x") "=d"))) "")
(define (sexpr->xml-bis lst )
  (define attrs '())
  (define value #f)
  (define ap #t)
  (define a1 #t)
  (define indent #t)
  (define tag #f)
;;;  (display* "\n" lst "\n")
  (if (pair? lst)
      (begin
	(if (eq? (car lst) 'keyed)
	    (with a (cadr lst)
		  (if (eq? (car a) 'tuple)
		      (set! attrs (cdr a))
		      (with l '()
			    (foreach (e a)
				     (set! l (cons (car e) l))
				     (set! l (cons (cadr e) l))
				     )
			    (set! attrs (reverse l))
			    ))
		  (set! value (caddr lst)))
	    (set! value lst)
	    )
					; 	(display* "attrs=" attrs "\n")
					; 	(display* "value=")(write value)(display "\n")

	;;; write the right open entity tag
	(set! tag (car value))
	(if (and (eq? (car value) 'with)
		 (string=? (cadr value) "mode")
		 (string=? (caddr value) "math"))
	    (begin (set! tag "formula")
		   (set! value (cddr value))))
	
	(set! indent (not (noindent-attr? tag)))
	(display "<" )
	(display tag )
	
	;;; write the attribute-value pairs
	(foreach-cons (e attrs)
		      ;; Attrs format :: (a1 v1 a2 v2 ... an vn)
		      (if (and ap (not (and a1 (excluded-attr? (car e)))))
			  (begin
			    (if a1 (display " " ))
			    (if (or a1 (not litteral-attrs-val?))
				(display (car e) )
				(write (car e)))
			    (if a1 (display "=" ))))
		      (if (not ap)
			  (set! ap #t))
		      (if (and a1 (excluded-attr? (car e)))
			  (set! ap #f))
		      (set! a1 (not a1))
		      )
	(if (eq? tag 'mappl)
	    (display* " name=" #\" (cadr value) #\" " " )
	    )
	
	(if (eq? tag '?xml)
	    (display "?" ))
	(display ">" )
	
	(if (and indent (not (null? (cdr value))))
	    (if (eq? tag '?xml)
		(newline)
		(xml-inc-cr-indent)))
	
	;;; write content of the entity 
	;;; special case for forall
	(with e (cadr value)
;;;	      (display* "forall? " e "\n")
	      (cond ((or (eq? tag 'mappl)
			 )
		     (xml-inc-cr-indent)
		     (map (lambda (arg)
			    (with args (string-split arg #\,)
				  (if (> (length args) 0)
				      (map (lambda (a)
					     (display* "<arg name=" #\" (string-trim-both a) #\" "/>" )
					     (xml-cr-indent)
					     )
					   args)
				      (begin
					(display* "<arg name=" #\" (string-trim-both arg) #\" "/>" )
					     ))
				  ))
			  (cddr value))
		     (xml-dec-cr-indent)
		     )
		    
		    ((and (eq? tag 'mforall)
			  )
;;		     (xml-inc-cr-indent)
		     (display* "<var name=" #\" (cadr value) #\" "/>" )
		     (xml-cr-indent)
		     (sexpr->xml-bis (caddr value) )
;;		     (xml-dec-cr-indent)
		     )		    
		    ((and (eq? tag 'mexists)
			  )
;;		     (xml-inc-cr-indent)
		     (display* "<var name=" #\" (cadr value) #\" "/>" )
		     (xml-cr-indent)
		     (sexpr->xml-bis (caddr value) )
;;		     (xml-dec-cr-indent)
		     )		    
		    (else (foreach-cons (e (cdr value))
					(sexpr->xml-bis (car e) )
					(if (not (null? (cdr e)))
					    (if indent
						(xml-cr-indent)
						(display " " )))
					))))

	;;; write entity's end tag 
	(if (and (not (null? (cdr value))) (not (eq? tag '?xml)))
	    (begin
	      (if indent
		  (xml-dec-cr-indent))
	      (display* "</" tag ">" )
	      )
	    (if (and indent (not (null? (cdr value))) (not (eq? tag '?xml)))
		(xml-dec-indent)))
	)
      (begin
	(cond ((null? lst)
	       ;;                (display "_")
	       )
	      ((and (string? lst)
		    (> (string-length (string-trim-both lst))
		       0))
	       (decompose-string (string-trim-both lst))
	       )
	      ;; if the input lst is not a pair (list)
	      (else
	       (display lst ))))
      ) 
  )

(define (decompose-string str)
  (with split (string-split str #\=)
	(if (and split
		 (> (length split) 1))
	    (begin (display "<meq>")
		   (xml-inc-cr-indent)
		   (display* "<arg name=" #\" (string-trim-both (car split)) #\" "/>")
		   (xml-cr-indent)
		   (display* "<arg name=" #\" (string-trim-both (cadr split)) #\" "/>")
		   (xml-dec-cr-indent)
		   (display "</meq>")
		   )
	    (with split2 (string-split str #\()
		  (if (and split2 (> (length split2) 1))
		      (with argStr (string-split (cadr split2) #\))
			    (display* "<mappl name=\"" (string-trim-both (car split2)) "\">")
			    (xml-inc-cr-indent)
			    (with args (string-split (first argStr) #\,)
				  (if (> (length args) 0)
				      (map (lambda (a)
					     (display* "<arg name=" #\" (string-trim-both a) #\" "/>")
					     (xml-cr-indent)
					     )
					   args)
				      (begin (display* "<arg name=" #\" (string-trim-both arg) #\" "/>")
					     ))
				  
				  (xml-dec-cr-indent)
				  (display "</mappl>")
				  ))
		      (display str))))))

(define (sexpr->xml lst)
  (sexpr->xml-bis lst)
  )
					;TODO: Ne pas oublier le cas particulier du
;  pretty-printing de <?xml>.
;  ==>
;    probablement pas necessaire.

;*************************************************************
;* Gestion des headers XML/RPC dans un sens et dans l'autre,
;* en particulier le Content-length dans le cas des inputs.
;*
(define rpcmsg "POST /RPC2 HTTP/1.0
User-Agent: Frontier/5.1.2 (WinNT)
Host: betty.userland.com
Content-Type: text/xml
Content-length: 181

<?xml version=\"1.0\"?>
<methodCall>
  <methodName>examples.getStateName</methodName>
  <params>
    <param>
      <value><i4>41</i4></value>
    </param>
  </params>
  </methodCall>
")

(define rpcmsg "HTTP/1.1 200 OK
Connection: close
Content-Length: 158
Content-Type: text/xml
Date: Fri, 17 Jul 1998 19:55:08 GMT
Server: UserLand Frontier/5.1.2-WinNT

<?xml version=\"1.0\"?>
<methodResponse>
  <params>
    <param>
      <value><string> South Dakota</string></value>
    </param>
  </params>
  </methodResponse>
")

(define xml-read-char read-char)
(define (xmlrpc-read sock)
  (define prec-c #f)
  (define c #f)
  (define (read-c)
     (set! prec-c c)
     (set! c (xml-read-char))
    ;(display* "c=" c "\n")
  )
  (define (read-const str)
     (define b #t)
     (foreach-number (i 0 < (string-length str))
        (if b
            (if (not (eq? (char-downcase (string-ref str i))
                          (char-downcase (xml-read-char))))
                (set! b #f)))
     )
     b
  )
  (define content-length 0)
  (define (proceed-length)
     (read-c)
     (if (in? c '(#\0 #\1 #\2 #\3 #\4 #\5 #\6 #\7 #\8 #\9))
         (begin
            (set! content-length (+ (* 10 content-length)
                                    (- (char->integer c)
                                       (char->integer #\0))))
            (proceed-length)))
  )
  (define (proceed-rest-of-header)
     (if (eq? (char->integer c) 13)
         (read-c))
     (if (eq? (char->integer c) 10)
         (begin
            (read-c)
            (if (eq? (char->integer c) 13)
                (read-c))
            (if (eq? (char->integer c) 10)
                #t
                (begin
                   (read-c)
                   (proceed-rest-of-header)))
         )
         (begin
            (read-c)
            (proceed-rest-of-header)))
  )
  (define (proceed-content)
     (define result "")
     (proceed-length)
    ;(display* "Length=" content-length "\n")
     (proceed-rest-of-header)
     (set! result (make-string content-length))
     (foreach-number (i 0 < content-length)
        (read-c)
        (string-set! result i c)
     )
     result
  )
  (define (proceed)
     (read-c)
     (if (and prec-c
              (eq? (char-downcase prec-c) #\c)
              (eq? (char-downcase c) #\o))
         (if (read-const "ntent-length: ")
             (proceed-content)
             (proceed)
         )
         (proceed))
  )
  (if (string? sock)
      (with-input-from-string sock proceed)
      (with-input-from-port sock proceed)))

(if TEST-XMLRPC
(begin
  (display "---\n")
  (write (xmlrpc-read rpcmsg))
  (display* "_\n")
  (display "---\n")
  (write (xml->sexpr (xmlrpc-read rpcmsg)))
  (display* "_\n")))
;(exit)

(define XMLRPC-REQUEST "POST /PLATO-OMEGA HTTP/1.0
User-Agent: TeXmacs
Host: plato.ags.uni-sb.de
Content-Type: text/xml
Content-length: "
)
(define XMLRPC-RESPONSE "HTTP/1.1 200 OK
Server: Plato
Connection: close
Content-Type: text/xml
Content-length: "
)
(define (xmlrpc-write sock msg req)
  (define (proceed)
     (display* (if req XMLRPC-REQUEST
                       XMLRPC-RESPONSE
               )
               (+ (string-length msg) 2) "\n\n" msg)
  )
  (if (string? sock)
      (with-output-to-string proceed)
      (with-output-to-port sock proceed))
)

(define (xml->sexpr-bis str)
  (define in-string? #f)
  (define in-tag? #f)
  (define in-tag-readed? #f)
  (define just-in-tag? #f)
  (define tag-has-attrs? #f)
  (define closing-tag? #f)
  (define autoclose-tag? #f)
  (define prev-c #f)
  (define stack (make-string 10000))
  (define stack-ptr 0)
  (define (push val)
     (string-set! stack stack-ptr val)
     (set! stack-ptr (+ stack-ptr 1)))
  (define (pop)
     (set! stack-ptr (- stack-ptr 1))
     (string-ref stack stack-ptr))
  (foreach-number (i 0 < (string-length str))
     (with c (string-ref str i)
        (if (and in-tag-readed? (xml-blank? c))
            (set! just-in-tag? #f))
        (cond (in-string?
               (display c)
               (if (eq? (char->integer c) 34)
                   (set! in-string? #f)))
              ((eq? (char->integer c) 34)
               (display c)
               (set! in-string? #t))
              ((and (xml-blank? c) val-as-string?)
               (display c))
              ((xml-blank? c) #t)
              ((eq? c #\<)
               (if val-as-string?
                   (begin
                      (set! val-as-string? #f)
                      (display (integer->char 34))))
               (set! in-tag? #t)
               (set! in-tag-readed? #f)
               (set! just-in-tag? #t)
               (set! tag-has-attrs? #f)
               (set! closing-tag? #f)
               (set! autoclose-tag? #f)
               (set! curtag-ptr 0))
              (val-as-string?
               (display c))
              ((eq? c #\/)
               (if just-in-tag?
                   (set! closing-tag? #t)
                   (if in-tag?
                       (set! autoclose-tag? #t))))
              ((eq? c #\>)
               (set! val-as-string?
                     (and prec-tag-value?
                          (equal? (string-upcase (substring curtag 0 curtag-ptr)) "STRING")))
               (set! in-tag? #f)
               (set! just-in-tag? #f)
               (if (and (not closing-tag?) (not autoclose-tag?))
                   (if (not tag-has-attrs?)
                       (push #\0)
                       (push #\1)))
;(display* "\n\ncurtag=" (substring curtag 0 curtag-ptr))
;(display* "\nstack-ptr=" stack-ptr "\nstack=" (substring stack 0 stack-ptr) "\n")
               (if tag-has-attrs?
                   (display* close-attr ")"))
               (if (not closing-tag?)
                   (display* "(" (substring curtag 0 curtag-ptr) " "))
               (if (or closing-tag? autoclose-tag?)
                   (display* ")"))
               (if (and closing-tag? (or hardcheck? (> stack-ptr 0)))
                   (with a (pop)
                      (if (eq? a #\1)
                          (display* ")"))))
               (if val-as-string?
                   (display (integer->char 34)))
               (set! tag-has-attrs? #f)
               (set! closing-tag? #f)
               (set! autoclose-tag? #f)
               (set! prec-tag-value?
                     (equal? (string-upcase (substring curtag 0 curtag-ptr)) "VALUE"))
;(display* "{{" (substring curtag 0 curtag-ptr) "}}")
;(display* "{{" prec-tag-value? "}}")
              )
              ((eq? c #\=)
               (if (and in-tag? tag-has-attrs?)
                   (display " ")))
              (else
                 (if just-in-tag?
                     (begin
                        (set! in-tag-readed? #t)
                        (string-set! curtag curtag-ptr c)
                        (set! curtag-ptr (+ curtag-ptr 1)))
                     (if in-tag?
                         (begin
                            (if (not (eq? c #\?))
                            (begin
                               (if (not tag-has-attrs?)
                                   (display "(keyed ("))
                               (if (xml-blank? prev-c)
                                   (begin
                                      (if tag-has-attrs?
                                          (display close-attr))
                                      (display open-attr)))
                               (set! tag-has-attrs? #t)
                               (display c)
                            ))
                         )
                         (begin
                            (if (xml-blank? prev-c)
                                (display " "))
                            (display c))))
              )
        )
        (set! prev-c c)))
)

; (define (sexpr->xml lst)
;   (sexpr->xml-bis lst)
;   )
(define (xml->sexpr str)
  (with-output-to-string
    (lambda ()
      (xml->sexpr-bis str)
      (display "))"))) ;; We need no more than 2 to compensate for a missing closing tag
  )
  
;; Some tests for the parsing
(define cmd "   <bcd a=\"Coucou, c'est <moi>\" b=v2 c=v3> < x> 1 2 3 < / x > < y / > < z / > < / bcd > ")
(define cmd "<?xml version=\"1.0\"?>
<methodCall>
   <methodName>examples.getStateName</methodName>
   <params>
      <param>
         <value><i4>41</i4></value>
         </param>
      </params>
   </methodCall>
</?xml>
")
(define cmd "<struct>
   <member>
      <name>lowerBound</name>
      <value><i4>18</i4></value>
      </member>
   <member>
      <name>upperBound</name>
      <value><i4>139</i4></value>
      </member>
   </struct>
")
(define cmd "<array>
   <data>
      <value><i4>12</i4></value>
      <value><string>Egypt</string></value>
      <value><boolean>0</boolean></value>
      <value><i4>-31</i4></value>
      </data>
   </array>
")
(define cmd "<?xml version=\"1.0\"?>
<methodResponse>
   <params>
      <param>
         <value><string>South Dakota</string></value>
         </param>
      </params>
   </methodResponse>
</?xml>
")
(define cmd "< ?xml version = \"1.0\" ?>
< methodResponse >
   < fault >
      < value >
         < struct >
            < member >
               < name > faultCode < / name >
               < value > < int > 4 < / int >< / value >
               < / member >
            < member >
               < name > faultString < / name >
               < value > < string > Too many parameters. < / string > < / value >
               < / member >
            < / struct >
         < / value >
      < / fault >
   < / methodResponse >
")

(if TEST-XMLRPC
(begin
  (write (xml->sexpr cmd))
  (display* "_\n")))
