open Lib
  
let proof = false 
    
type clause = Clause.clause
type lit = Term.literal
type term = Term.term
type symbol = Symbol.symbol  
type tmp = bool
(*type prop_var = PropSolver.var *)
type prop_lit = PropSolver.lit
      
      
exception Unsatisfiable
exception Satisfiable
exception DontKnow
    
let param_str_ref = ref ""
let pref_str = "------ "
let add_param_str str = 
  param_str_ref := (!param_str_ref)^pref_str^str

(***********************selection function*************)

(*
let selection_fun  = Selection.lit_var_neg_big 
let ()=add_param_str ("Selection Selection.lit_var_neg_big \n")
*)

(*
let selection_fun  = Selection.lit_neg_var_big 
let ()=add_param_str ("Selection Selection.lit_neg_var_big \n")
*)
(*
let selection_fun  = Selection.lit_var_neg_shallow
let ()= add_param_str("Selection Selection.lit_var_neg_sh \n")
*)

(* let selection_fun  = Selection.lit_var_big_neg *)
(* let ()= add_param_str("Selection Selection.lit_var_big_neg\n") *)

 let selection_fun  = Selection.lit_var_sh_neg 
 let ()=add_param_str ("Selection Selection.lit_var_sh_neg \n") 

(*
let selection_fun  = Selection.lit_neg_var_sh
let ()=add_param_str ("Selection Selection.lit_neg_var_sh  \n") 
*)
(*
let selection_fun  = Selection.lit_pos_var_sh
let ()=add_param_str ("Selection Selection.lit_pos_var_sh  \n") 
*)
(*let selection_fun  = Selection.lit_pos_big_var*)
(*let ()=add_param_str ("Selection Selection.lit_pos_big_var  \n") *)


let ()=add_param_str ("Duplicates removal; Dismatching Constr. with No Features; \n")


(*let selection_fun  = Selection.lit_neg_gr_shallow    *)


let symbol_db_ref  = Parsed_input_to_db.symbol_db_ref
(*ugly*)
let neg_symb       = Parsed_input_to_db.neg_symb
let bot_symb       = Parsed_input_to_db.bot_symb      
let bot_term       = Parsed_input_to_db.bot_term      
    
let term_db_ref    = Parsed_input_to_db.term_db_ref
    
let init_clause_list_ref = Parsed_input_to_db.clause_list_ref
let clause_db_ref = ref (ClauseAssignDB.create_name "Instantiation_Clauses_DB")
    
(* simple passive is just a list and *)
(* only is used in the instantiation_exhaustive_loop*)
(*  *)
    
let simple_passive_ref = ref []

(* unprocessed is a list of newly generated clauses *)
(* we cannot put them to passive since some truth val of some var *)
(* can be not defined at this stage *)

let unprocessed_ref    = ref []    

(*for statistics*)
let num_of_instantiation_iter  = ref 0
let num_of_solver_calls        = ref 0
(*let num_in_passive        = ref 0     *)
let num_in_simple_passive = ref 0
let num_in_passive        = ref 0
let num_in_active         = ref 0     
let num_moves_active_passive = ref 0 
let num_of_duplicates = ref 0
let num_of_learning_restarts = ref 0

let out_statistics () = 
  out_str 
    ( "num of inst_loop iterations: "
      ^(string_of_int !num_of_instantiation_iter)^"\n"
      ^"num of clauses in db: "
      ^(string_of_int (ClauseAssignDB.size !clause_db_ref))^"\n"
    (*  ^"num_in_simple_passive: "
      ^(string_of_int !num_in_simple_passive)^"\n"*)
      ^"num_in_passive: "
      ^(string_of_int !num_in_passive)^"\n"
      ^"num_in_active: "
      ^(string_of_int !num_in_active)^"\n"
      ^"num_of_solver_calls: "
      ^(string_of_int !num_of_solver_calls)^"\n"
      ^"num_of_moves_active_passive: "
      ^(string_of_int !num_moves_active_passive)^"\n"   
      ^"num_of_dismatch_blockings: " 
      ^(string_of_int !Inference_rules.num_of_dismatch_blockings)^"\n"
      ^"num_of_non_proper_inst: "
      ^(string_of_int !Inference_rules.num_of_non_proper_inst)^"\n"
      ^"num of learning restarts: "
      ^(string_of_int !num_of_learning_restarts)^"\n"
      ^"number of simplified duplicates:"    
      ^(string_of_int !Inference_rules.num_of_duplicates)^"\n"
(*  ^(string_of_int !num_of_duplicates)^"\n"*)
     )
    



let out_proof s = 
  if proof then out_str s
  else ()
    
(********** complementary literal ugly *******)
let compl_lit literal = 
  match literal with 
  | Term.Fun(sym,args,_) -> 
      if (Symbol.get_type sym)= Symbol.Neg 
      then List.hd (Term.arg_to_list args)  
      else Term.create_fun_term neg_symb [literal]
  |_-> failwith "term: compl_lit it is not a literal" 
 




(******************get term for grounding**************)
  
(* get_term_for_grounding *)
(* gets term as constant with maximal occurences in all clauses *)
   
(* const_ass_list -- assosiation *)
(* list of constants with number of occurences*)
    
type const_ass_list = symbol * (int ref) list 
  
(* finds constant with max value in ass list*)

let rec find_const_max' var_num const_ass_list =
  let (var,num_ref)=var_num in
  match const_ass_list with 
  | h::tl -> let (v_next,num_next_ref) = h in
    if !num_next_ref > !num_ref 
    then find_const_max' h tl
    else find_const_max' var_num tl
  |[] -> var_num
      
let find_const_max const_ass_list =
  match const_ass_list with 
  | h::tl -> find_const_max' h tl
  | [] ->  raise Not_found

(* gets an const_ass_list an returnes new one with added occurences of *)
(* constants according to term *)
let rec get_symb_ass_list_term const_ass_list term = 
  if (Term.is_constant term) 
  then
    try 
      let num_of_occ_ref = List.assq term const_ass_list in
      num_of_occ_ref := !num_of_occ_ref + 1;
      const_ass_list
    with 
      Not_found ->
	(term, ref 1)::const_ass_list
  else			 
    match term with 
    |Term.Fun(symb,t_args,_) -> 
	let f curr_ass_list t = get_symb_ass_list_term curr_ass_list t in
	Term.arg_fold_left f const_ass_list t_args
    |Term.Var(_,_) -> const_ass_list
	  
(* the same as above but for clause *)
let get_symb_ass_list_clause const_ass_list clause =
  List.fold_left 
    get_symb_ass_list_term const_ass_list (Clause.get_literals clause)

let get_term_for_grounding () = 
  let  symb_ass_list =
    List.fold_left get_symb_ass_list_clause [] !init_clause_list_ref in
  try 
    let (max_const,num_ref) = find_const_max symb_ass_list in
    (*out_str_debug ("max constant "^(Term.to_string max_const)
               	   ^" num of occurences "^(string_of_int !num_ref)^"\n");*)
    max_const
  with 
    Not_found -> 
      bot_term


(**********end get grounding term******************)

(********* propositional interpretation ************)

type prop_var_entry = 
    {var_id              : int param;
     prop_var            : prop_lit param; 
     prop_neg_var        : prop_lit param;
     mutable truth_val   : PropSolver.lit_val param;
(* list of clauses for which selection is based on this var *)
     mutable sel_clauses : (clause list);
(* used only for output of model*)
     mutable ground_term : lit param
   } 

let var_entry_to_string solver prop_var_entry = 
  let var_solver_val_str =
    match prop_var_entry.prop_var with
    |Def(prop_var) ->
(* need to check if solver was called at all before *)
	(match prop_var_entry.truth_val with
	|Def(_) -> 
	    PropSolver.lit_val_to_string (PropSolver.lit_val solver prop_var) 
	|_-> " Solver was Not Called " 
	)
    |_-> " Var is undef "
  in
  "var_id: "^(param_to_string string_of_int prop_var_entry.var_id)
  ^"; current truth_val: "
  ^(param_to_string PropSolver.lit_val_to_string prop_var_entry.truth_val)
  ^"; Solver truth val: "^(var_solver_val_str)
  ^"; Ground term: "^(param_to_string Term.to_string prop_var_entry.ground_term)


let var_entry_sel_to_string solver prop_var_entry = 
  try
    let clause_list_str =  
      let get_cl_str rest clause = 
	let sel_lit = Clause.get_inst_sel_lit clause in
	let sel_str = "\n Selected:  "^(Term.to_string sel_lit)^"\n" in
	let clause_str = " In clause: "^(Clause.to_string clause) in
	rest^sel_str^clause_str 
      in			       
      List.fold_left get_cl_str "" prop_var_entry.sel_clauses
    in
    (var_entry_to_string solver prop_var_entry)^clause_list_str
  with
    Clause.Inst_sel_lit_undef -> 
      failwith "var_entry_sel_cl_to_string: Sel_lits_undef "


let empty_var_entry = 
  {
   var_id       = Undef;
   prop_var     = Undef;
   prop_neg_var = Undef;
   truth_val    = Undef;
   sel_clauses  = [];
   ground_term  = Undef;
 }

let create_var_entry solver var_id ground_term = 
  {
   var_id       = Def(var_id);
   prop_var     = Def(PropSolver.create_lit solver PropSolver.Pos var_id); 
   prop_neg_var = Def(PropSolver.create_lit solver PropSolver.Neg var_id); 
   truth_val    = Undef;
   sel_clauses  = [];
   ground_term  = Def(ground_term)
 }


let var_table_initsize = 20

let var_table = TableArray.create var_table_initsize empty_var_entry

let model_to_string_gen entry_to_str =
  let init_str   = "\n ------------Model-----------\n" in
  let final_str = "\n ----------END Model----------\n" in
  let main_str=
    let get_entry_str rest entry = 
      rest ^ "\n---------------------------------\n"
      ^(entry_to_str entry)^"\n" in
    TableArray.fold_left get_entry_str "" var_table  
  in 
  init_str^main_str^final_str


let model_to_string solver  =  model_to_string_gen  (var_entry_to_string solver)

let model_sel_to_string solver =  
  model_to_string_gen  (var_entry_sel_to_string solver)


(* *)
let get_prop_key_assign solver gr_by term = 
  try Term.get_prop_key term
  with Term.Prop_key_undef ->
    let gr_term = 
      try Term.get_grounding term      
      with
	Term.Term_grounding_undef ->
	  let new_gr_t = Subst.grounding term_db_ref gr_by term in 
	  Term.assign_grounding new_gr_t term;
	  new_gr_t
    in
    try 
      let new_key = Term.get_prop_key gr_term in
      Term.assign_prop_key new_key term;
      new_key
    with Term.Prop_key_undef ->	
      let new_key = TableArray.get_next_key var_table in
(* var_id > 0 *)
      let var_id  = TableArray.key_to_int new_key + 1 in
      let var_entry = create_var_entry solver var_id gr_term in
      TableArray.assign var_table new_key var_entry;
      Term.assign_prop_key new_key term;
      Term.assign_prop_key new_key gr_term;
      new_key

(* adds literal after grounding to propositional solver and to var_table *)
let get_prop_lit solver gr_by lit =
  let atom = Term.get_atom lit in 
  let atom_prop_key = get_prop_key_assign solver gr_by atom in
  let prop_var_entry = TableArray.get var_table atom_prop_key in
  let def_lit = 
    if (Term.is_neg_lit lit) 
    then      
      prop_var_entry.prop_neg_var 
    else
     prop_var_entry.prop_var 
  in
  match def_lit with 
  |Def(lit) -> lit 
  | _ -> failwith "Insatntiation get_prop_lit: lit is undefind"
	

let add_clause_to_solver solver gr_by clause =
  let lits = Clause.get_literals clause in
  let prop_lit_list = List.map (get_prop_lit solver gr_by) lits in
  (* debug*) 
  let str = list_to_string PropSolver.lit_to_string prop_lit_list ";" in
  (*out_str_debug ("Clause: "^(Clause.to_string clause)^"\n"
		 ^"Prop Clause:"^str^"\n");*)
  PropSolver.add_clause solver prop_lit_list


let get_prop_var_entry lit = 
  try 
    let atom           = Term.get_atom lit in
    let prop_key       = Term.get_prop_key atom in
    TableArray.get var_table prop_key
  with 
    Term.Prop_key_undef -> failwith "get_prop_var_entry : Term.Prop_key_undef"

let get_truth_var_entry var_entry = 
  match var_entry.truth_val with	
  |Def(truth_val) -> truth_val
  |Undef ->   failwith "get_truth_var_entry: truth_val is Undef\n"

let get_prop_var_var_entry var_entry =
  match var_entry.prop_var with	
  |Def(prop_var) -> prop_var
  |Undef ->   failwith "get_prop_var_var_entry: prop_var is Undef\n"


(********* end propositional interpretation ************)

(*************** unprocessed **********************)
let add_clause_to_unprocessed clause = 
  unprocessed_ref:=clause::!unprocessed_ref
			     
(*************** simple passive *********************)

exception Passive_Simple_Empty 
let remove_from_simple_passive () = 
  match !simple_passive_ref with 
  | clause::tl -> 
      simple_passive_ref := tl;
      Clause.set_bool_param false Clause.in_passive clause;
      num_in_simple_passive:=!num_in_simple_passive-1;
      clause
  |[]     -> raise Passive_Simple_Empty 
	
let add_to_simple_passive clause = 
  simple_passive_ref := clause::!simple_passive_ref;
  num_in_simple_passive:=!num_in_simple_passive+1;
  Clause.set_bool_param true Clause.in_passive clause; 
  Clause.assign_when_born !num_of_instantiation_iter clause

(*add new clauses*)    
let add_new_clause_to_sp clause = 
  if (Clause.is_empty_clause clause) 
  then
    raise Unsatisfiable
  else 
    if (not (Clause.get_bool_param Clause.is_dead clause))  
    then 
	  add_to_simple_passive clause 
    else ()


(*************** end simple passive *********************)

(************* Passive Queue *********************)
(* alternative to simple passive *)
(* to make dismatching constraints cut more we need to prefer *)
(* shallow sel lits/ clauses *)

let cmp_num_var_sel c1 c2 =
  try 
  -(compare (Term.get_num_of_var (Clause.get_inst_sel_lit c1)) 
      (Term.get_num_of_var (Clause.get_inst_sel_lit c2)))
  with 
    Clause.Inst_sel_lit_undef -> cequal

let cmp_num_var c1 c2 =
  -(compare (Clause.num_of_var c1) (Clause.num_of_var c2))

let cmp_size c1 c2 = 
  -(compare (Clause.num_of_sym c1) (Clause.num_of_sym c2))  

let cmp_ind c1 c2 = (Clause.compare c1 c2)  


let ()= add_param_str 
    ("Passive Queue: lex_combination [cmp_num_var;cmp_size]\n")

module PassQueueElem = 
  struct
    type t = clause
    let compare c1 c2 =  
      let lex_compare = lex_combination 
	  [cmp_num_var;cmp_size;cmp_ind] in
      lex_compare c1 c2
  end
    
module PassQueue = Heap.Functional (PassQueueElem) 
let passive_queue_ref = ref (PassQueue.empty)

exception Passive_Empty 
let remove_from_passive () = 
  if !passive_queue_ref = PassQueue.empty
  then raise Passive_Empty 
  else
    let clause =  PassQueue.maximum !(passive_queue_ref) in 
    passive_queue_ref := PassQueue.remove !(passive_queue_ref);
    Clause.set_bool_param false Clause.in_passive clause;
    num_in_passive:=!num_in_passive-1;
    clause
 
	
let add_to_passive clause = 
  passive_queue_ref := PassQueue.add clause !(passive_queue_ref); 
  num_in_passive:=!num_in_passive+1;
  Clause.set_bool_param true Clause.in_passive clause; 
  Clause.assign_when_born !num_of_instantiation_iter clause
    
(*add new clauses*)    
let add_new_clause_to_passive clause = 
  if (Clause.is_empty_clause clause) 
  then
    raise Unsatisfiable
  else 
    if (not (Clause.get_bool_param Clause.is_dead clause))  
    then 
	  add_to_passive clause 
    else ()


(*************** unification index **********************)

module DTParam = 
  struct let num_of_symb = (SymbolDB.size !symbol_db_ref) end 
module DiscrTreeM = DiscrTree.Make(DTParam)  

(* all clauses with the same literal put together, *)
(*   assoc list with == *)

type unif_index_elem = (lit*(clause list)) list

let (unif_index_ref : (unif_index_elem DiscrTreeM.index) ref ) 
    = ref (DiscrTreeM.create ())
    
(* add to unif index *)
      
let add_to_unif_index main_clause =
  try
    let sel_lit = Clause.get_inst_sel_lit main_clause in
 (* out_str_debug ("Add to Unif Index: Clause: "^(Clause.to_string main_clause) *)
 (*	 ^"  literals:  "^(Term.to_string sel_lit)^"\n"); *)
    let ind_elem = DiscrTreeM.add_term_path sel_lit unif_index_ref in
    (match !ind_elem with 
    |Elem(old) -> 
	(try
	  let old_clause_list =  List.assq sel_lit old in 
	  let old_with_removed = List.remove_assq sel_lit old in
	  ind_elem := 
	    Elem((sel_lit,(main_clause::old_clause_list))::old_with_removed)
	  with Not_found ->  ind_elem := Elem((sel_lit,[main_clause])::old)
	)	     
    |Empty_Elem   -> 	 
	ind_elem := Elem([(sel_lit,[main_clause])])
    );     
    Clause.set_bool_param true Clause.in_unif_index main_clause
  with
    Clause.Inst_sel_lit_undef -> 
      failwith "add_to_unif_index: clause should have selected literals here"



(************eliminates clause!*****************)

let eliminate_from_unif_index main_clause = 
  try
    let sel_lit = Clause.get_inst_sel_lit main_clause in
    (*out_str_debug 
      ("Trying to elim from Unif index:"
      ^(Clause.to_string main_clause)
      ^" Literals: "
      ^(Term.to_string sel_lit)^"\n");
     *)
    (try  
      let ind_elem = DiscrTreeM.find sel_lit !unif_index_ref
	(* failwith "discount:  eliminate_from_unif_index lit is in unif_index" *)
      in
      ( match !ind_elem with 
      |Elem(old) ->
	  ( (* old = [(L1,[C_1,..,Cn]),(L2,[C'_1,..,C'n']),..]  
	       old_clause_list = [C_1,..,Cn] corr to sel_lit*)
	    (*  try *) 
	    let old_clause_list  = List.assq sel_lit old in 
            (*  out_str_debug 
		("Elem From Unif index old_cl_list:"
		^(Clause.clause_list_to_string old_clause_list)^"\n"); *)   
	    let old_with_removed = List.remove_assq sel_lit old in
	    
(*remove main_clause*)     
	    let new_clause_list = 
	      List.find_all (fun cl -> not(cl == main_clause)) old_clause_list in
	    (* out_str_debug 
	       ("Elem From Unif index new_cl_list:"
	       ^(Clause.clause_list_to_string new_clause_list)^"\n"); *)
            if new_clause_list = [] 
	    then 
 	      if  old_with_removed = []
		then
		(DiscrTreeM.remove_term_path sel_lit unif_index_ref
                   (*; out_str_debug 
		     ("Elim unif Removed term path"
		     ^(Term.to_string sel_lit)^"\n")*))
	      else 
		  (ind_elem := Elem(old_with_removed)
                      (*; out_str_debug 
			("Elim unif: Old_with_removed")*))
	    else 	    
	      (ind_elem := 
		Elem((sel_lit,new_clause_list)::old_with_removed)
		  (*;out_str_debug 
		    ("Elim unif: Old_with_removed")*) )		
		(*with *)
		(*  Not_found -> ()*)
	   )
    | Empty_Elem -> 
	  failwith "discount: eliminate_from_unif_index  \
	    unif index should not contain Empty_Elem"  
       )     
    with
      Not_found -> 
	out_str 
      ("\n Warning: eliminate_from_unif_index: the clause in not in the index!\n ")
  ); 
    Clause.set_bool_param  
      false Clause.in_unif_index main_clause 
  with 
    Clause.Inst_sel_lit_undef -> 
      failwith "eliminate_from_unif_index: Clause.Sel_lits_undef "
  
(************** end  unification index **********************)

(*************** simplification  ***)
exception Clause_Simplified 
let simplify clause = 
  if (ClauseAssignDB.mem clause !clause_db_ref)
  then  
    (num_of_duplicates:= !num_of_duplicates+1;
     (*out_str_debug ("\n Simplified: "^(Clause.to_string clause)^"\n"); *)  
  raise Clause_Simplified)
  else clause

(****************end simplification*******************)
(*
let dismatching_string clause =   
  try 
   "["^(Dismatching.constr_list_to_string (Clause.get_dismatching clause))^"]"
  with
    Clause.Dismatching_undef -> "[]"
*)

(*************** apply_new_model_sp ************)

let add_to_active clause = 
  if not (Clause.get_bool_param Clause.in_active clause)
   then
    (Clause.set_bool_param true Clause.in_active clause;
      add_to_unif_index clause;
     num_in_active := !num_in_active +1
    )
  else ()

let remove_from_active clause =
  if (Clause.get_bool_param Clause.in_active clause) 
  then 
    (eliminate_from_unif_index clause;
     Clause.set_bool_param false Clause.in_active clause;
     num_in_active := !num_in_active -1
    )
  else ()

(* simple passive version*)
let move_from_active_to_sp clause = 
  remove_from_active clause; 
  add_to_simple_passive clause;
  num_moves_active_passive:=!num_moves_active_passive+1

let move_from_active_to_passive clause = 
  remove_from_active clause; 
  add_to_passive clause;
  num_moves_active_passive:=!num_moves_active_passive+1




(* PropSolver.Any  as false *)	
let lit_val_to_bool lit_val = 
  match lit_val with
  |PropSolver.Any   -> false
  |PropSolver.True  -> true 
  |PropSolver.False -> false

(*
let is_true_in_model solver lit = 
  let is_neg         = Term.is_neg_lit lit in    
  let var_entry      = get_prop_var_entry lit in
  let prop_var       = get_prop_var_var_entry var_entry in
  match var_entry.prop_var with	
  |Def(prop_var) -> 
      let var_truth_val = PropSolver.lit_val solver prop_var in
      if
	((lit_val_to_bool var_truth_val) & (not is_neg)) ||  
	((not (lit_val_to_bool var_truth_val)) & is_neg)
      then true
      else false
  |Undef ->  failwith "is_true_in_model : prop_var is Undef\n"
*)

let is_true_in_solver solver lit = 
  let is_neg         = Term.is_neg_lit lit in    
  let var_entry      = get_prop_var_entry lit in
  let prop_var       = get_prop_var_var_entry var_entry in
  let var_truth_val  = PropSolver.lit_val solver prop_var in
  if
    ((lit_val_to_bool var_truth_val) & (not is_neg)) ||  
    ((not (lit_val_to_bool var_truth_val)) & is_neg)
  then true
  else false

(* returns true if it does and otherwaise change the model and return false *)
let model_accords_solver solver var_entry = 
  let prop_var      = get_prop_var_var_entry var_entry in
  let old_truth_val = get_truth_var_entry var_entry in
  let new_truth_val = PropSolver.lit_val solver prop_var in
  if (old_truth_val =  new_truth_val)
  then true
  else 
    (var_entry.truth_val <- Def(new_truth_val); 
     List.iter move_from_active_to_passive var_entry.sel_clauses;
     var_entry.sel_clauses <- [];
     false)

(* we assume that the clause is from passive and therefore *)
(* not assigned in to any of var_entry.sel_clauses *)

exception Sel_Changed  
let selection_renew solver clause = 
  try
    let sel_lit       = Clause.get_inst_sel_lit clause in    
    let sel_is_neg    = Term.is_neg_lit sel_lit in 
    let var_entry     = get_prop_var_entry sel_lit in

    if (is_true_in_solver solver sel_lit) 
    then 
      let _= model_accords_solver solver var_entry in
      var_entry.sel_clauses <- clause::(var_entry.sel_clauses)
    else
      raise Sel_Changed     
  with
    Sel_Changed | Clause.Inst_sel_lit_undef ->
      (let new_sel_lit = 
	selection_fun (is_true_in_solver solver) clause in
      Clause.assign_inst_sel_lit new_sel_lit clause;
      let new_var_entry = get_prop_var_entry new_sel_lit in
      let _= model_accords_solver solver new_var_entry in
      new_var_entry.sel_clauses <- clause::(new_var_entry.sel_clauses)
      ) 
	
exception Sel_Unchanged
let apply_new_model solver = 
  let sel_is_changed = ref false in
  let change_entry var_entry =
    let prop_var = get_prop_var_var_entry var_entry in
    match var_entry.truth_val with	
    |Def(_) -> 	
	if (model_accords_solver solver var_entry) 
	then ()
	else sel_is_changed:=true
    |Undef ->
	(    (* sel_is_changed:=true; *)
	let new_truth_val = PropSolver.lit_val solver prop_var in
	var_entry.truth_val <- Def(new_truth_val)
	)
  in
  TableArray.iter change_entry var_table;  
  if !sel_is_changed then ()
  else 
    raise Sel_Unchanged

 
(*************** end apply_new_model ************)
    
(************ all_instantiations ********)
let all_instantiations solver gr_by main_clause =
  try 
    (*we assume that sel in main_clause is checked before *)
    (*on accordance with solver*)
    let sel_lit = Clause.get_inst_sel_lit main_clause in
     (*out_str_debug ("all_instantiations_sp main clause "*)
      (*  ^(Clause.to_string main_clause)^"\n");*)
    let compl_sel_lit = compl_lit sel_lit in
    let unif_candidates = 
      DiscrTreeM.unif_candidates !unif_index_ref compl_sel_lit in
    let for_all_candidates (lit,clause_list) =       
      (*out_str_debug ("inst_try: "^(Clause.to_string main_clause)*)
      (*^(Clause.clause_list_to_string clause_list)); *) 
      try 
	(let var_entry     = get_prop_var_entry lit in
	if (model_accords_solver solver var_entry)
	then
	  (
	   let conclusion_list = 
	     Inference_rules.instantiation_norm
	       term_db_ref clause_db_ref main_clause sel_lit compl_sel_lit 
	       clause_list lit in		  
           let apply_to_concl clause =  
	    (*try *)
(* uncoment this if back to  constrint checking then simplifed *)
	      (* let simplified_clause = simplify clause in	 *)
	    let simplified_clause = clause in
(* uncoment this if back to  constrint checking then simplifed *)
	    (* let added_clause = 
		ClauseAssignDB.add_ref clause clause_db_ref in *)          
	    let added_clause = clause in
	    add_clause_to_solver solver gr_by added_clause;
            add_clause_to_unprocessed added_clause
	    (* with Clause_Simplified -> ()*)	  	  	    
	   in
	   List.iter apply_to_concl conclusion_list    
	  )
	else () (*  model_accords_solver will move all clauses to passive!*)
	)
      with Unif.Unification_failed  -> ()       
    in	
    List.iter for_all_candidates unif_candidates
  with
    Clause.Inst_sel_lit_undef -> 
      failwith "all_instantiations: clause should have selected literals here"
	
(************ end all_instantiations ********)

(**************** instantiation_exhaustive_loop *********************)
(* we exhaustivelly apply instantiations util passive is empty *)
(* then apply prop_solver *)
    
let rec instantiation_exhaustive_loop solver gr_by =
  let stat_counter = ref 0 in
  while true do  
    (*  out_str_debug 
	("instantiation_exhaustive_loop \n "
	^(string_of_int !num_of_instantiation_iter));*)
    num_of_instantiation_iter := !num_of_instantiation_iter + 1;  
    stat_counter := !stat_counter +1;
(* often output of statistic *)
   (* (if !stat_counter > 1000 then (stat_counter:=0; out_statistics ()) else ());*)
    try  
    (*  let clause = remove_from_simple_passive () in*)
      let clause = remove_from_passive () in
      if ((Clause.get_bool_param Clause.is_dead clause) ||
      (Clause.get_bool_param Clause.in_active clause))
      then () 
      else
(* sp for simple passive *)
	(selection_renew solver clause;
	 all_instantiations solver gr_by clause;
	 add_to_active clause)	
    with
    |Passive_Empty ->
	(if (PropSolver.solve solver) = PropSolver.Unsat 
	then raise Unsatisfiable
	else 
	  try
 	    List.iter add_new_clause_to_passive !unprocessed_ref;
	    unprocessed_ref:=[];
	    apply_new_model solver;
	    num_of_solver_calls := !num_of_solver_calls +1
	   (* out_str_debug (model_sel_to_string ())*)
	  with 
	    Sel_Unchanged -> 
	      if (*!simple_passive_ref =[] *)
		!passive_queue_ref = PassQueue.empty
	      then raise Satisfiable
	      else())
    |PropSolver.Unsatisfiable -> raise Unsatisfiable
  done

(**************** instantiation loop with each clause added to passive *)
(******************solver called**************)
(* replace here simple passive to passive*)
let rec instantiation_each_loop solver_per_active solver gr_by =
  let stat_counter = ref 0 in
  let solver_counter = ref 0 in
  while true do  
  (*  out_str_debug 
      ("instantiation_exhaustive_loop \n "
      ^(string_of_int !num_of_instantiation_iter));*)
    num_of_instantiation_iter := !num_of_instantiation_iter + 1;  
    stat_counter := !stat_counter +1;
    solver_counter:=!solver_counter+1;
(* often output of statistic *)
  (*  (if !stat_counter > 1000 then (stat_counter:=0; out_statistics ()) else ());*)
 
    try  
(* test run solver every loop *)
     (* if (PropSolver.solve solver) = PropSolver.Unsat 
      then raise Unsatisfiable
      else*)       
	(if ((!solver_counter > solver_per_active ) || 
	(!passive_queue_ref =PassQueue.empty))
	then 
	  if (!unprocessed_ref = []) && (!passive_queue_ref =PassQueue.empty)
	  then raise Satisfiable
	  else
	    (solver_counter:=0;	 
	     num_of_solver_calls := !num_of_solver_calls +1; 
	   if (PropSolver.solve solver) = PropSolver.Unsat 
	   then raise Unsatisfiable
	   else       
	     (List.iter add_new_clause_to_passive !unprocessed_ref;
	      unprocessed_ref:=[];
	      try
		apply_new_model solver
	      with
		Sel_Unchanged -> 
		  if (!passive_queue_ref =PassQueue.empty)
		  then raise Satisfiable
		  else()
	     )	
	  )
	else
	  let clause = remove_from_passive () in       
	if ((Clause.get_bool_param Clause.is_dead clause) ||
	(Clause.get_bool_param Clause.in_active clause))
	then () 
	else	 
	  (selection_renew solver clause;
	   all_instantiations solver gr_by clause;
	   add_to_active clause)       
	)
   with	  
    |Passive_Empty -> ()
    |PropSolver.Unsatisfiable -> raise Unsatisfiable
  done

(****************end instantiation_each_loop***************)

(***************instantiation lazy loop***********************)
(*we change model patially and lazily for literals detected having different *)
(* value in the solver vs in the model *)

(*
let rec instantiation_lazy_loop solver_per_active solver gr_by =
  let stat_counter = ref 0 in
  let solver_counter = ref 0 in
  while true do  
  (*  out_str_debug 
      ("instantiation_exhaustive_loop \n "
      ^(string_of_int !num_of_instantiation_iter));*)
    num_of_instantiation_iter := !num_of_instantiation_iter + 1;  
    stat_counter := !stat_counter +1; (* out statistic after some steps*)
    solver_counter:=!solver_counter+1;
(* often output of statistic *)
  (*  (if !stat_counter > 1000 then (stat_counter:=0; out_statistics ()) else ());*)
    try  
      (if !solver_counter > solver_per_active  
      then       
	(num_of_solver_calls := !num_of_solver_calls +1;
	 if (PropSolver.solve solver) = PropSolver.Unsat 
	 then raise Unsatisfiable
	 else solver_counter:=0));      
      let clause = remove_from_passive () in       
      if 
	((Clause.get_bool_param Clause.is_dead clause) ||
	(Clause.get_bool_param Clause.in_active clause))
      then () 
      else	 
	((*out_str_debug ("Given Clause: "^(Clause.to_string clause)^"\n");*)
	 selection_renew solver clause;
	(* out_str_debug ("Sel in Given: "^ *)
	(*		(Term.to_string (Clause.get_inst_sel_lit clause)^"\n"));*)
	(* out_str_debug (model_sel_to_string solver); *)
	 all_instantiations solver gr_by clause;
	 add_to_active clause)       	
    with	  
    |Passive_Empty -> 
	(if (PropSolver.solve solver) = PropSolver.Unsat 
	then raise Unsatisfiable
	else 
	  try
 	    List.iter add_new_clause_to_passive !unprocessed_ref;
	    unprocessed_ref:=[];
	    apply_new_model solver;
	    num_of_solver_calls := !num_of_solver_calls +1
		(* out_str_debug (model_sel_to_string ())*)
	  with 
	    Sel_Unchanged -> 
	      (if (*!simple_passive_ref =[] *)
		!passive_queue_ref = PassQueue.empty
	      then  ((*out_str_debug (model_sel_to_string solver); *)
		     raise Satisfiable)
	      else())
	)	  
    |PropSolver.Unsatisfiable -> raise Unsatisfiable
  done
*)

let lazy_loop_body solver_counter solver_per_active solver gr_by =
  num_of_instantiation_iter := !num_of_instantiation_iter + 1;  
  solver_counter:=!solver_counter+1;
  try  
    (if !solver_counter > solver_per_active  
    then       
      (num_of_solver_calls := !num_of_solver_calls +1;
       if (PropSolver.solve solver) = PropSolver.Unsat 
       then raise Unsatisfiable
       else solver_counter:=0));      
    let clause = remove_from_passive () in       
    if 
      ((Clause.get_bool_param Clause.is_dead clause) ||
      (Clause.get_bool_param Clause.in_active clause))
    then () 
    else	 
      ((*out_str_debug ("Given Clause: "^(Clause.to_string clause)^"\n");*)
	selection_renew solver clause;
       (* out_str_debug ("Sel in Given: "^ *)
       (*		(Term.to_string (Clause.get_inst_sel_lit clause)^"\n"));*)
       (* out_str_debug (model_sel_to_string solver); *)
       all_instantiations solver gr_by clause;
       add_to_active clause)       	
  with	  
  |Passive_Empty -> 
      (if (PropSolver.solve solver) = PropSolver.Unsat 
      then raise Unsatisfiable
      else 
	try
 	  List.iter add_new_clause_to_passive !unprocessed_ref;
	  unprocessed_ref:=[];
	  apply_new_model solver;
	  num_of_solver_calls := !num_of_solver_calls +1
	      (* out_str_debug (model_sel_to_string ())*)
	with 
	  Sel_Unchanged -> 
	    (if (*!simple_passive_ref =[] *)
		(!passive_queue_ref = PassQueue.empty) &&  (!unprocessed_ref=[])
	    then  (*out_str_debug (model_sel_to_string solver); *)
	      raise Satisfiable
	    else())
      )	  
  |PropSolver.Unsatisfiable -> raise Unsatisfiable
      

let rec instantiation_lazy_loop solver_per_active solver gr_by =
  let solver_counter = ref 0 in
  let stat_counter   = ref 0 in
  while true do
(*    (if !stat_counter > 1000 then (stat_counter:=0; out_statistics ()) else ());*)
    lazy_loop_body solver_counter solver_per_active solver gr_by;
(*    stat_counter := !stat_counter +1*)
  done 

let prop_learning_loop solver_per_active solver gr_by = 
  let solver_counter   = ref 0 in
  let learning_start   = ref 500 in 
  let learning_factor  = 2 in 
  let learning_counter = ref 0 in
  add_param_str
    (
     "Learning Loop: "
     ^"start: "^(string_of_int !learning_start)
     ^"; factor: "^(string_of_int learning_factor)
     ^"; Solver per Active: "^(string_of_int solver_per_active)
     ^" \n");
  while true do
    if !learning_counter < !learning_start 
    then
      (lazy_loop_body solver_counter solver_per_active solver gr_by;
       learning_counter:=!learning_counter+1)
    else
      (learning_start:=!learning_start * learning_factor;
       learning_counter:=0;
       num_of_learning_restarts:= !num_of_learning_restarts+1;
(* clear all clause DB, except solver*)
       clause_db_ref :=  
	 (ClauseAssignDB.create_name 
	    ("Instantiation_Clauses_DB: "^(string_of_int !num_of_learning_restarts)));
       passive_queue_ref := PassQueue.empty;
       unprocessed_ref := [];    
       num_in_passive:=0;
       num_in_active:=0;
       let add_cl clause =
	 let new_clause   = Clause.create (Clause.get_literals clause) in
	 let added_clause = 
	   ClauseAssignDB.add_ref new_clause clause_db_ref in             
	 add_clause_to_unprocessed added_clause in
       List.iter add_cl !init_clause_list_ref
       (*out_str_debug ("Learning restart: "^(string_of_int !num_of_restarts)^"\n");
       out_statistics ()*)
      )
  done

(************************ end lazy loop **********************************)

(* tests *)
let test_sel () =  
  let truth_f term = true in
  let sel_lit clause =
    Selection.lit_neg_gr_shallow truth_f clause in
  let to_str rest clause =
    rest^"Clause: "^(Clause.to_string clause)^"\n"
    ^"Sel: "^(Term.to_string (sel_lit clause))^"\n" in
  List.fold_left to_str "" !init_clause_list_ref

let start_instantiation () = 
  try
    let grounding_term = get_term_for_grounding  () in
    (* out_str_debug ("Term for grounding: "^(Term.to_string grounding_term)^"\n");*)
    let solver = PropSolver.create_solver () in
    let equality_axioms = Eq_axioms.axiom_list () in
   (* out_str_debug ("Equality Axioms:\n" 
	      ^(Clause.clause_list_to_string equality_axioms)^"\n"); *)
   (* out_str_debug 
      ("Init Clauses: \n"
       ^(Clause.clause_list_to_string !init_clause_list_ref));*)
    init_clause_list_ref:= equality_axioms@(!init_clause_list_ref);
    let add_cl_to_solver_and_unprocessed clause =
      try 
	let simplified_clause = simplify clause in	     
	let added_clause = 
	  ClauseAssignDB.add_ref clause clause_db_ref in             
	add_clause_to_solver solver grounding_term added_clause;
	add_clause_to_unprocessed added_clause
	(*out_str_debug ((Clause.to_string added_clause)^"\n")*)
      with Clause_Simplified -> ()   
    in
    List.iter add_cl_to_solver_and_unprocessed !init_clause_list_ref;
    if (PropSolver.solve solver) = PropSolver.Unsat 
    then raise Unsatisfiable
    else 
      (
       (try
         apply_new_model solver;
       with 
	 Sel_Unchanged ->  
	   if !unprocessed_ref = [] then raise Satisfiable
	   else ()
       );
	 (let solver_per_active = 1000 in
	 add_param_str
	   (
	    "Lazy Loop: "
	    ^"Solver per Active: "^(string_of_int solver_per_active)
	    ^"\n");
	  (*instantiation_each_loop solver_per_active solver grounding_term*)
	 out_str !param_str_ref;
	 instantiation_lazy_loop solver_per_active solver grounding_term

	     
(*	       out_str 
		       ("--------Instantiation Exhaustive Loop----------\n");
		 instantiation_exhaustive_loop solver grounding_term*)
(*	
	 prop_learning_loop solver_per_active solver grounding_term
*)
	 )
      )
  with
  |Unsatisfiable |PropSolver.Unsatisfiable -> 
      out_str "PROVED\n";
      out_statistics ()	  	
  |Satisfiable   -> 
      out_str "SATISFIABLE\n";  
      out_statistics ()


 (*out_str (test_sel ())*)


(* 
let start_instantiation () = 
(* get term for grounding*)
  let num_of_sym = SymbolDB.size !symbol_db_ref in
  (if  num_of_sym < !actual_num_of_sym_groups_ref
  then actual_num_of_sym_groups_ref := num_of_sym);  
  partition_symbols !actual_num_of_sym_groups_ref;
    let add_clause clause = 
      add_new_clause_to_passive clause clause
    in
    List.iter add_clause !init_clause_list_ref;
    (* ClauseAssignDB.iter add_caluse !init_clause_db_ref; *)
   (* out_str_debug "initial clauses are added to passive \n";*)
    try  discount_loop () with
    |Unsatisfiable -> 
	out_str "\n PROVED";
	out_statistics ()	  	
    |Satisfiable   -> 
	out_str "\n SATISFIABLE";  
	out_statistics ()

*)
