type symbol
type fast_key 
type stype =  
  |Fun|Pred|And|Or|Impl|Forall|Exists
  |Neg|True|False|Equality|Plus|Minus|UnaryMinus|Bot

exception Symbol_fast_key_undef
exception Arity_undef
exception Group_undef

val  create_from_str       : string -> stype -> symbol
val  create_from_str_arity : string -> stype -> int -> symbol 

(* fast key assigned when symbolDB is creating*)
val  assign_fast_key       : symbol -> int -> unit

val assign_group           : symbol -> int -> unit
val assign_is_input        : bool -> symbol  -> unit
val assign_is_skolem       : bool -> symbol  -> unit


val  to_string             : symbol -> string
val  to_prolog             : symbol -> string

val  get_arity             : symbol -> int
val  get_type              : symbol -> stype
val  get_group             : symbol -> int
val  get_is_input          : symbol -> bool
val  get_is_skolem         : symbol -> bool

   
(* compare = compare_fast_key and should not be used before 
   fast_key is assigned i.e. symbolDB build (the same to equal and hash); 
   before that use compare_key *)  


val compare               : symbol -> symbol -> int 
val equal                 : symbol -> symbol -> bool
val compare_key           : symbol -> symbol -> int
val compare_fast_key      : symbol -> symbol -> int
val hash                  : symbol -> int
