type   symbol = Symbol.symbol
      
module SymKey = 
  struct 
    type t       = symbol
    let  compare = Symbol.compare_key
    let  assign_fast_key = Symbol.assign_fast_key
 end
    
module SymbolDBM =  AbstAssignDB.Make (SymKey)
type symbolDB  = SymbolDBM.abstDB

let create_name = SymbolDBM.create_name
let create ()   = create_name "Symbol_DB"
let get_name = SymbolDBM.get_name
let mem    = SymbolDBM.mem   
let remove = SymbolDBM.remove
let find   = SymbolDBM.find
let size   = SymbolDBM.size
let map    = SymbolDBM.map
let add_ref = SymbolDBM.add_ref
let add = SymbolDBM.add
let fold = SymbolDBM.fold
let iter = SymbolDBM.iter

  
let to_string symbol_db = 
  SymbolDBM.to_string Symbol.to_string "," symbol_db

(*debug*)
let get_greatest_key = SymbolDBM.get_greatest_key
